import java.awt.Graphics;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Hashtable;


public class kworldClient {
	
	public String name;

	public String hostName = "localhost";
	public int PORT = 10000;
	private serverConnect server;
	
	private	int chatStart;
	
	private boolean connected;
	
	public static Hashtable<String, playerInfo> Players;
	
	@SuppressWarnings("unchecked")
	public static Hashtable [] drawOrder;
	
	class playerInfo {
		int X;
		int Y;
		int Race;
		int SDIndex;
		int aniFrame;
		boolean recievedHello;
		long lastDrawTime;
		int lastAniFrame;
		playerInfo()
		{
			X = 0;
			Y = 0;
			Race = 0;
			SDIndex = 0;
			aniFrame = 0;
			lastAniFrame = 0;
			lastDrawTime = 0;
			recievedHello = false;
		}
	}
	
	public ArrayList<String> players;
	public ArrayList<String> chatText;
	
	private kworld KW;
	
	public kworldClient(kworld kw)
	{
		KW = kw;
		connected = false;
		Players = new Hashtable<String, playerInfo>();
		
		drawOrder = new Hashtable[100];
		for (int i = 0; i < drawOrder.length; i++)
			drawOrder[i] = new Hashtable<String, playerInfo>();
		
		chatText = new ArrayList<String>();
		chatStart = 0;
	}
	
	public void stop() {
		if (server != null)
			server._writeObject(new SD_PlayerDel(null));
	}
	
	public void connect()
	{
		addToChat("Connecting...");
		server = new serverConnect(this);
	}
	
	public void setChatPos(int num)
	{
		if (chatText.size() > 5) {
			chatStart = num;
			if (chatStart < 0)
				chatStart = 0;
			else if (chatText.size() > 5 && chatStart >= (chatText.size() - 5))
				chatStart = (chatText.size() - 5);
		} else
			chatStart = 0;
	}
	
	public int getChatPos()
	{
		return chatStart;
	}
	
	public void drawPlayers(int mapX, int mapY, int yPos, Graphics g)
	{
		if (yPos > -1 && yPos < drawOrder.length) {

			Enumeration<?> e = drawOrder[yPos].keys();
			while (e.hasMoreElements()) {
				String playername = (String) e.nextElement();
				if (playername.equals(name))
					continue;

				playerInfo pi = (playerInfo) drawOrder[yPos].get(playername);
				if (pi.recievedHello) {
					KW.spriteEngine.drawOthers(playername, mapX, mapY, pi.Race, pi.SDIndex, pi.aniFrame, pi.X, pi.Y, g);
					if (pi.lastAniFrame != pi.aniFrame) {
						pi.lastDrawTime = System.currentTimeMillis() + 500;
						pi.lastAniFrame = pi.aniFrame;
					} else if (pi.aniFrame != 0 && pi.lastDrawTime < System.currentTimeMillis()) {
						pi.lastAniFrame = pi.aniFrame = 0;
					}
				}
			}
		}
	}
	
	public void drawChatText(Graphics g)
	{
		int start = 0;
		int end = chatText.size();
		int x = 112;
		int y = 390;

		if (chatText.size() > 5) {
			if (chatStart >= 0) {
				start = chatStart;
			} else
				start = chatText.size() - 5;
			end = start + 5;
		}
		for (int i = start; i < end; i++) {
			String msg = (String)chatText.get(i);
			g.drawString(msg, x, y);
			y += 12;
		}
		
	}
	public void addToChat(String msg)
	{
		chatText.add(msg);
		while (chatText.size() > 100)
			chatText.remove(0);
		setChatPos(chatText.size() - 5);
		System.out.println(msg);
	}
	
	public void setConnected(boolean bool) 
	{
		if (bool) {
			addToChat("Connected");
			connected = bool;
		} else {
			addToChat("!!!NOT!!! Connected");
			connected = bool;
		}
	}
	
	public void error(String s)
	{
		addToChat(s);
	}
	
	
	public void close()
	{
		error("Connection to server was lost");
		Players.clear();
	}
	
	public void sendHello()
	{
		KW.sendMove();
	}
	
	public String getLocationNameByID(int ID)
	{
		String rtnName = "KrabbitWorld";
		switch(ID) {
			case 0: rtnName = "KrabbitWorld"; break;
			case 1: rtnName = "Kerbanzai Forest"; break;
			case 2: rtnName = "Droolus Swamp"; break;
			case 3: rtnName = "Staramia"; break;
			case 4: rtnName = "Spunky Ville"; break;
		}
			
		return rtnName;
	}

	public void sendChat(String msg)
	{
		if (connected && server != null) {
			if (msg.startsWith("/t ") || msg.startsWith("/w ")) {
				String [] tmp = msg.substring(3, msg.length() - 3).split(" ");
				String tellName = tmp[0];
				int len = (3+1+tellName.length());
				String outMsg = msg.substring(len);
				if (msg.startsWith("/t ")) {
					server._writeObject(new SD_Private(tellName, outMsg));
					addToChat("tell " + tellName + ": " + outMsg);
				} else {
					server._writeObject(new SD_Whisper(tellName, outMsg));
					addToChat("whisper " + tellName + ": " + outMsg);
				}
				
			} else if (msg.startsWith("/who")) {
				server._writeObject(new SD_Who(name));
			} else {
				server._writeObject(new SD_Chat(name, msg));
				addToChat(name + ": " + msg);
			}
		}
	}
	
	public void sendMove(String name, int race, int index, int frame, int x, int y)
	{
		if (connected && server != null)
			server._writeObject(new SD_Move(name, race, index, frame, x, y));
	}
	
	@SuppressWarnings("unchecked")
	public void doMove(String name, int race, int index, int frame, int x, int y)
	{
		playerInfo inPlayer = (playerInfo) Players.get(name);
		
		int oldY = 0;
		
		if (inPlayer == null) {
			inPlayer = new playerInfo();
			inPlayer.X = x;
			inPlayer.Y = y;
			inPlayer.Race = race;
			inPlayer.SDIndex = index;
			inPlayer.recievedHello = true;
			inPlayer.aniFrame = frame;
			Players.put(name, inPlayer);
		} else {
			inPlayer.X = x;
			oldY = inPlayer.Y;
			inPlayer.Y = y;
			inPlayer.Race = race;
			inPlayer.aniFrame = frame;
			inPlayer.SDIndex = index;
			inPlayer.recievedHello = true;
		}
		int dindex = KW.worldTiles.getPlayerY() + oldY;
		if (dindex > -1 && dindex < drawOrder.length)
			drawOrder[dindex].remove(name);
		dindex = KW.worldTiles.getPlayerY() + inPlayer.Y;
		if (dindex > -1 && dindex < drawOrder.length)
			drawOrder[dindex].put(name, inPlayer);

		//addToChat("name: " + name + " race: " + race + " index: " + index + " frame: " + frame + " x: " + x + " y: " + y);
	}
	
	public void sendLocation(int location)
	{
		if (server != null)
			server._writeObject(new SD_Location(location));
		
	}
	
	public void playerAdd(String playerName)
	{
		if (!Players.containsKey(playerName)) {
			Players.put(playerName, new playerInfo());
			if (!playerName.equals(name))
				addToChat(playerName + " has joined " + getLocationNameByID(server.location));
		}
	}
	
	public void playerDel(String playerName)
	{
		if (Players.containsKey(playerName)) {
			playerInfo delPlayer = (playerInfo) Players.get(playerName);
			if (delPlayer != null) {
				int dindex = KW.worldTiles.getPlayerY() + delPlayer.Y;
				if (dindex > -1 && dindex < drawOrder.length)
					drawOrder[dindex].remove(playerName);
			}
			
			Players.remove(playerName);
			//addToChat(playerName + " has left " + getLocationNameByID(server.location));
		}
	}
	
	public void recieveChat(String playerName, String message) {
		addToChat(playerName + ": " + message);
	}
	public void recieveWhisper(String playerName, String message) {
		addToChat("whisper from " + playerName + ": " + message);
	}
	public void recievePrivate(String playerName, String message) {
		addToChat("tell from " + playerName + ": " + message);
	}
	
	public void recieveError(String message) {
		addToChat("Error: " + message);
	}

}
