import java.util.LinkedList;

public class messageQueue implements Runnable {
	private static final int MAX_SIZE = 15;
	private LinkedList<Object> queue;
	private socketConnection sockC;
	private boolean running;
	private boolean empty;
	
	public messageQueue(socketConnection sc)
	{
		sockC = sc;
		queue = new LinkedList<Object>();
		running = true;
		empty = true;
		new Thread(this).start();
	}
	
	synchronized public boolean addTo(Object obj) {
		queue.addLast(obj);
		if (empty) {
			empty = false;
			notify();
		}
		if (queue.size() > MAX_SIZE) {
			sockC.close();
		}
		return true;
	}
	
	public void run() {
		while (running) {
			try {
				if (queue.size() != 0) {
					sockC._writeObject(queue.removeFirst());
				} else {
					empty = true;
					synchronized(this) {
						while (empty) {
							wait();
						}
					}
				}
				Thread.sleep(10);
			} catch ( InterruptedException e ) {
				System.out.println("messageQueue error: " + e);
				running = false;
			}
		}
	}

}
