import javax.net.ssl.*;
import java.io.ObjectOutputStream;
import java.io.ObjectInputStream;
import java.io.IOException;

public class serverConnect implements Runnable, socketConnection {

	kworldClient client;
	
	private SSLSocket socket;
	private ObjectOutputStream out;
	private ObjectInputStream in;
	
	public boolean connected;
	public boolean finalized;
	private boolean helloSent;
	public int location;
	
	private messageQueue queue;
	
	public serverConnect(kworldClient kwc)
	{
		client = kwc;
		connected = false;
		finalized = false;
		helloSent = false;
		queue = new messageQueue(this);
		location = 0;
		
		try {
			client.addToChat("initSocket");
			// initialize socket
			SSLSocketFactory sslFact = (SSLSocketFactory)SSLSocketFactory.getDefault();
			client.addToChat("createSocket " + client.hostName + " " + client.PORT);
			socket = (SSLSocket)sslFact.createSocket(client.hostName, client.PORT);

			// Checking the supported Cipher suites.
			client.addToChat("enabledCipher");
			String [] enabledCipher = socket.getSupportedCipherSuites ();
			// Enabled the Cipher suites.
			client.addToChat("setEnabledCipherSuites");
			socket.setEnabledCipherSuites (enabledCipher);

			// make in/out stream connection
			out = new ObjectOutputStream(socket.getOutputStream());
			in = new ObjectInputStream(socket.getInputStream());
			connected = true;
			client.setConnected(true);
			new Thread(this).start();
		} catch (IOException e) {
			client.error("Server not available");
			client.setConnected(false);
			connected = false;
		}
	}
	
	private socketData readObject() {
		try {
			return (socketData) in.readObject();
		} catch (Throwable t) {
			return null;
		}
	}
	
	public void writeObject(Object obj) {
		queue.addTo(obj);
	}
	
	public void _writeObject(Object obj) {
		if (connected) {
			try {
				out.writeObject(obj);
				out.flush();
			} catch (IOException e) {
				close();
			}
		}
	}
	
	public void close() {
		try {
			connected = false;
			client.setConnected(false);
			if (connected) socket.close();
		} catch (IOException e) { }
		client.close();
	}

// =======================================================
	public void playerAdd(String playername)
	{
		client.playerAdd(playername);
	}
	
	public void playerDel(String playername)
	{
		client.playerDel(playername);
	}
	
	public void kick(String playername)
	{
		client.name = null;
	}
	
	public void location(int locationNum)
	{
		location = locationNum;
		client.addToChat("you have entered " + client.getLocationNameByID(location));
	}
	
	public void move(String name, int race, int index, int frame, int x, int y)
	{
		client.doMove(name, race, index, frame, x, y);
	}
	
	
	public void chat(String playername, String message)
	{
		if (!helloSent) {
			if (playername.equals("server") && message.indexOf("Welcome to KrabbitWorld") > -1) {
				client.sendHello();
				helloSent = true;
			}
		}
		if (playername.equals("Who")) {
			client.addToChat("Who List");
			client.addToChat(message);
		} else
			client.recieveChat(playername, message);
	}
	public void private_msg(String playername, String message)
	{
		client.recievePrivate(playername, message);
	}
	public void whisper(String playername, String message)
	{
		client.recieveWhisper(playername, message);
	}

	public void error(String err)
	{
		client.recieveError(err);
	}
	
	public void who(String playername)
	{
	}

// =======================================================
	public void run() {
		writeObject(new SD_PlayerAdd(client.name));
		client.addToChat("sending name: " + client.name);

		socketData sd;
		while (connected && (sd = readObject()) != null) {
			sd.performAction(this);
		}
		close();
	}
}
