import java.awt.Color;
import java.awt.Graphics;
import java.awt.Image;
import java.util.ArrayList;

public class sprite
{
	private ArrayList<spriteData> sprites;

    private long nextFrameTime;
    private long duration;
    private int currFrame;
    
    private long lastMoveTime = 0;
    
    private int currSpriteDataIndex;
    private int raceIndex;

    private tiles worldTiles;
    private kworld KW;

    private class spriteData {
    	Image image;
    	int maxFrames;
    	int width;
    	int height;
    	public spriteData(Image image, int maxFrames, int width) {
    		this.image = image;
    		this.maxFrames = maxFrames;
    		this.width = width;
    		this.height = image.getHeight(null);
    	}
    }
    
    //constructer
    public sprite(kworld kw, tiles inTiles)
    {
    	worldTiles = inTiles;
    	KW = kw;
        nextFrameTime = 0;
        duration = 0;
        currFrame = 0;
        currSpriteDataIndex = 0;
        raceIndex = 0;
        sprites = new ArrayList<spriteData>();
    }

    public void addSprite(Image image, int width, int frameDuration, int numFrames)
    {
        if (image != null) {
            duration = frameDuration;
            sprites.add(new spriteData(image, numFrames, width));
        }
    }

    public synchronized void updateAni(boolean isMoving, long currentTime) 
    {
        if (getMaxFrame() > 0) {
        	if (isMoving) {
        		lastMoveTime = currentTime + 500;
                if (nextFrameTime < currentTime) {
                    nextFrameTime = currentTime + duration;
                    currFrame++;
                    if (currFrame >= getMaxFrame())
                        currFrame = 0;
                }
        	} else if (lastMoveTime < currentTime) {
        		int checkFrame = currFrame;
        		currFrame = 0;
        		if (checkFrame != 0) {
        			KW.sendMove();
        		}
        	}
        }
    }

    public int getCurrFame()
    {
        return currFrame;
    }

    private Image getImage()
    {
    	if (sprites.size() == 0)
    		return null;
    	else
    		return getSprite().image;
    }
    
    public int getSDIndex()
    {
    	return currSpriteDataIndex;
    }
    public void setSpriteIndex(int index)
    {
    	currSpriteDataIndex = index;
    }
    public void setRace(int race)
    {
    	raceIndex = race * 4;
    }
    private spriteData getSprite()
    {
    	if (currSpriteDataIndex < sprites.size())
    		return (spriteData)sprites.get(raceIndex + currSpriteDataIndex);
    	return null;
    }

    private int getMaxFrame()
    {
    	if (sprites.size() == 0)
    		return 0;
    	else
    		return getSprite().maxFrames;
    }
    
    private int getWidth()
    {
    	if (sprites.size() == 0)
    		return 0;
    	else
    		return getSprite().width;
    }
    
    private int getHeight()
    {
    	if (sprites.size() == 0)
    		return 0;
    	else
    		return getSprite().height;
    }
    
    public void drawMainPlayer (int x, int y, Graphics g)
    {
        g.clipRect(x, y - getHeight(), getWidth(), getHeight());
        g.drawImage(getImage(), x - (getCurrFame() * getWidth()) , y - getHeight(), null);
        g.setClip(null);
    }
    
    public void drawOthers (String othersName, int mapX, int mapY, int race, int SDIndex, int currFrame, int inX, int inY, Graphics g)
    {
    	//worldTiles
    	if ((race + SDIndex) < sprites.size()) {
    		int x = inX - mapX;
    		int y = inY - mapY;
    		x += worldTiles.getPlayerX();
    		y += worldTiles.getPlayerY();
    		x *= worldTiles.getTileSize();
    		y *= worldTiles.getTileSize();
    		x-=5;
    		y+=32;
    		spriteData sd = (spriteData)sprites.get((race * 4) + SDIndex);
        	g.clipRect(x, y - sd.height, sd.width, sd.height);
        	g.drawImage(sd.image, x - (currFrame * sd.width) , y - sd.height, null);
        	g.setClip(null);
        	
        	g.setColor(Color.white);
        	g.drawString(othersName, x - 1, y - (sd.height + 5));
        	g.setColor(Color.black);
    	}
    }
}

