import java.io.*;
import java.awt.Graphics;
import java.awt.Image;

public class tiles {
	
	private static final int BLOCKED = 100;
	private static final int LOCATION_WORLD = 0;

	private static final int NOTHING = -1;
	//private static final int ENTRANCE = 3000;
	private static final int TOWNENTERANCE = 3000;
	private static final int FORESTENTERANCE = 4000;
	//private static final int OBJECTS = 1000;
	private static final int OBJTREE = 1001;
	private static final int OBJSIGN = 1002;
	
	private boolean resetMapCoards;
	private int mapLocation;
	private int worldX;
	private int worldY;
	
	private int [][] tileMap;
	private int [][] tileBlocker;
	
	private int tileSize;
	private int tileMaxX;
	private int tileMaxY;
	private Image tileImage;
	
	private Image treeImage;
	private Image signImage;
	
	private int PlayerCenterX;
	private int PlayerCenterY;
	
	private kworldClient client;
	
	public int getDrawPlayerX()
	{
		return PlayerCenterX * tileSize;
	}

	public int getDrawPlayerY()
	{
		return PlayerCenterY * tileSize;
	}
	
	public int getPlayerX()
	{
		return PlayerCenterX;
	}

	public int getPlayerY()
	{
		return PlayerCenterY;
	}
	
	public int getTileSize()
	{
		return tileSize;
	}
	
	public int getMapLocation()
	{
		return mapLocation;
	}

	public void setTiles(Image image, Image treeObj, Image signObj, int size, int width, int height)
	{
		tileImage = image;
		treeImage = treeObj;
		signImage = signObj;
		tileSize = size;
		tileMaxX = width / tileSize;
		tileMaxY = height / tileSize;
		PlayerCenterX = (tileMaxX/2);
		PlayerCenterY = (tileMaxY/2);
	}
	
	public tiles(kworldClient kwc)
	{
		client = kwc;
		tileSize = 32;
		tileMaxX = 640 / tileSize;
		tileMaxY = 480 / tileSize;
		PlayerCenterX = (tileMaxX/2);
		PlayerCenterY = (tileMaxY/2);
		tileMap = new int[100][100];
		tileBlocker = new int[100][100];
		resetMapCoards = false;
		mapLocation = getLocationID("maps/world.map");
		worldX = 0;
		worldY = 0;
	}
	
	private int getLocationID(String mapName)
	{
		int rtn = 0;
		if (mapName.equals("maps/world.map"))
			rtn = 0;
		else if (mapName.equals("maps/forest1.map"))
			rtn = 1;
		else if (mapName.equals("maps/forest2.map"))
			rtn = 2;
		else if (mapName.equals("maps/town1.map"))
			rtn = 3;
		else if (mapName.equals("maps/town2.map"))
			rtn = 4;
			
		return rtn;
	}
	
	public void loadMap(String mapName) throws IOException
	{
		int x = 0;
		int y = 0;

	    try {
	    	InputStream is = getClass().getResourceAsStream(mapName);
	        InputStreamReader isr = new InputStreamReader(is);
	        BufferedReader br = new BufferedReader(isr);
	        String line;
	        while (null != (line = br.readLine())) {
	        	String [] vals = line.split(" ");
				tileMap[x][y] = Integer.valueOf(vals[0]);
				tileBlocker[x][y] = Integer.valueOf(vals[1]);
				//System.out.println(tileMap[x][y]);
				x++;
				if (x >= 100) {
					x = 0;
					y++;
				}
	        }
	        is.close();
	        isr.close();
	        br.close();
	        resetMapCoards = true;
	    }
	    catch (Exception e) {
			e.printStackTrace();
			System.err.println("File input error");
	    }		
	}
	
	public boolean isBlocked(int xPos, int yPos)
	{
		int x = xPos + PlayerCenterX;
		int y = yPos + PlayerCenterY;
		if (x > -1 && y > -1 && x < 100 && y < 100) {
			if (tileBlocker[x][y] == BLOCKED)
				return true;
			else if (tileBlocker[x][y] >= FORESTENTERANCE) {
				String mapName = "maps/forest"+(tileBlocker[x][y] - FORESTENTERANCE)+".map";
				try {
		        	loadMap(mapName);
		        	if (mapLocation == LOCATION_WORLD) {
		        		worldX = xPos;
		        		worldY = yPos;
		        	}
		        	mapLocation = getLocationID(mapName);
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				return true;
			} else if (tileBlocker[x][y] >= TOWNENTERANCE &&
					tileBlocker[x][y] < FORESTENTERANCE) {
				String mapName = "maps/town"+(tileBlocker[x][y] - TOWNENTERANCE)+".map";
				try {
		        	loadMap(mapName);
		        	if (mapLocation == LOCATION_WORLD) {
		        		worldX = xPos;
		        		worldY = yPos;
		        	}
		        	mapLocation = getLocationID(mapName);
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				return true;
			} else if (tileMap[x][y] == NOTHING &&
					mapLocation != LOCATION_WORLD) {
				try {
		        	loadMap("maps/world.map");
		        	mapLocation = getLocationID("maps/world.map");
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				return true;
			}
			return false;
		}
		return true;
	}
	
	public boolean resetMapXY(int [] x, int [] y)
	{
		boolean returnBool = resetMapCoards;
		if (resetMapCoards) {
			if (mapLocation == LOCATION_WORLD) {
				x[0] = worldX;
				y[0] = worldY+1;
			} else {
				x[0] = -5;
				y[0] = -1;
			}
		}
		resetMapCoards = false;
		return returnBool;
	}
	
	public void drawObjs (int xPos, int yPos, Graphics g)
	{
		for (int y = 10; y < tileMaxY+10; y++) {
            for (int x = -10; x < tileMaxX; x++) {
            	if ((xPos+x > -1 && yPos+y > -1) && (xPos+x < 100 && yPos+y < 100)) {
                	if (tileBlocker[xPos+x][yPos+y] == OBJTREE)
                		g.drawImage(treeImage, (x * tileSize), (y * tileSize)-(treeImage.getHeight(null)), null);
                	else if (tileBlocker[xPos+x][yPos+y] == OBJSIGN)
                		g.drawImage(signImage, (x * tileSize), (y * tileSize)-(signImage.getHeight(null)), null);
                }
            }
			client.drawPlayers(xPos, yPos, yPos+y-2, g);
		}
	}
	
	public void drawTiles (int xPos, int yPos, Graphics g)
	{
		int waterTile = 22;
		
		for (int y = 0; y < tileMaxY; y++) {
            for (int x = -10; x < tileMaxX; x++) {
            	int col = 0;
            	int row = 0;
            	if ((xPos+x < 0 || yPos+y < 0) || (xPos+x > 99 || yPos+y > 99)) {
            		col = waterTile - (tileMaxX * (waterTile / tileMaxX));
            		row = waterTile / tileMaxX;
            	} else {
            		col = tileMap[xPos+x][yPos+y];
                	row = 0;
                	if (tileMap[xPos+x][yPos+y] >= tileMaxX) {
                    	col = tileMap[xPos+x][yPos+y] - (tileMaxX * (tileMap[xPos+x][yPos+y] / tileMaxX));
                    	row = tileMap[xPos+x][yPos+y] / tileMaxX;
                	}
            	}
                g.clipRect(x * tileSize, y * tileSize, tileSize, tileSize);
                g.drawImage(tileImage, (x * tileSize)-(col * tileSize) , (y * tileSize)-(row * tileSize), null);
                g.setClip(null);
                
                if (y < 10 && (xPos+x > -1 && yPos+y > -1) && (xPos+x < 100 && yPos+y < 100)) {
                	if (tileBlocker[xPos+x][yPos+y] == OBJTREE)
                		g.drawImage(treeImage, (x * tileSize), (y * tileSize)-(treeImage.getHeight(null)), null);
                	else if (tileBlocker[xPos+x][yPos+y] == OBJSIGN)
                		g.drawImage(signImage, (x * tileSize), (y * tileSize)-(signImage.getHeight(null)), null);
                }
            }
            
			client.drawPlayers(xPos, yPos, yPos+y-2, g);
            
		}
	}
}
