import javax.net.ssl.SSLServerSocket;
import javax.net.ssl.SSLServerSocketFactory;
import javax.net.ssl.SSLSocket;

import java.io.*;
import java.util.Hashtable;
import java.util.LinkedList;
import java.util.Enumeration;

public class kworldServer extends Thread {

	private static kworldServer listenServer;
	public static int PORT = 10000;
	public static LinkedList<playerConnect> connectingPlayers;
	public static Hashtable<String, playerConnect> connectedPlayers;
	public static locationManager locations;
	
	public static boolean running;
	
	public void Log(String msg)
	{
		System.out.println(msg);
	}
	
	synchronized public void addPlayer(SSLSocket s)
	{
		playerConnect pc = new playerConnect(this, s);
		connectingPlayers.add(pc);
		Log("kworldServer AddPlayer");
	}
	
	synchronized public boolean finalizePlayer(String playername, playerConnect pc)
	{
		if (connectedPlayers.containsKey(playername) || connectedPlayers.contains(pc)) {
			pc.writeObject(new SD_Error("Player name already exists, please choose a different one."));
			Log("Player name already exists");
			return false;
		} else if (playername.length() > 10) {
			pc.writeObject(new SD_Error("Player too long, only 10 letters allowed."));
			Log("Player too long");
			return false;			
		} else if (connectingPlayers.remove(pc)) {
			pc.writeObject(new SD_Chat("server", "Welcome to KrabbitWorld!"));
			connectedPlayers.put(playername, pc);
			broadcast(new SD_PlayerAdd(playername), playername, pc.location);
			sendPlayerList(pc);
			Log("finalizePlayer success");
			return true;
		}
		
		return false;
	}
	
	synchronized public void sendPlayerList(playerConnect pc)
	{
		Enumeration<?> e = connectedPlayers.keys();
		while (e.hasMoreElements()) {
			String playername = (String) e.nextElement();
			if (pc.Name.equals(playername)) {
				continue;
			}
			playerConnect o = (playerConnect) connectedPlayers.get(playername);
			if (o.location == pc.location) {
				pc.writeObject(new SD_Move(o.Name, o.getRace(), o.getSDIndex(), o.getAniFrame(), o.getX(), o.getY()));
			}
		}
	}
	
	synchronized public boolean sendTo(socketData sd, String to) {
		playerConnect o = (playerConnect) connectedPlayers.get(to);
		if (o != null) {
			o.writeObject(sd);
			return true;
		} else {
			return false;
		}
	}
	
	public void run() 
	{
		//Runtime.getRuntime().addShutdownHook(new ShutdownServer(this));
		try {
			SSLServerSocketFactory factory = (SSLServerSocketFactory) SSLServerSocketFactory.getDefault();
			SSLServerSocket sslIncoming = (SSLServerSocket) factory.createServerSocket (PORT);
			String [] enabledCipher = sslIncoming.getSupportedCipherSuites ();
			sslIncoming.setEnabledCipherSuites (enabledCipher);
			
			while(running) {
				SSLSocket s = (SSLSocket)sslIncoming.accept();
				addPlayer(s);
			}
			
			
		} catch (IOException e) { 
			System.out.println("kworldServer Error: " + e); 
		}
	}
	/*
	public class ShutdownServer extends Thread {
		private kworldServer kws;
		ShutdownServer( kworldServer srv )
		{
			kws = srv;
		}
		public void run()
		{
						
		}
	}*/
	
	synchronized public void broadcast(socketData sd, String from) {
		Enumeration<?> e = connectedPlayers.keys();
		while (e.hasMoreElements()) {
			String to = (String) e.nextElement();
			if (!to.equals(from)) {
				playerConnect o = (playerConnect) connectedPlayers.get(to);
				o.writeObject(sd);
			}
		}
	}
	
	synchronized public void broadcast(socketData sd, String from, int location) {
		Enumeration<?> e = connectedPlayers.keys();
		while (e.hasMoreElements()) {
			String to = (String) e.nextElement();
			if (!to.equals(from)) {
				playerConnect o = (playerConnect) connectedPlayers.get(to);
				if (o.location == location) {
					o.writeObject(sd);

				}
			}
		}
	}
	
	synchronized public void kill(playerConnect pc) {
		try {
			if (pc.Name != null && connectedPlayers.remove(pc.Name) == pc) {
				locations.delPlayer(pc.location);
				broadcast(new SD_Location(pc.location), pc.Name);
				delete(pc);
			}
		} catch (NullPointerException e) {
			e.printStackTrace();
			if (pc != null) {
				System.out.println("null pointer on kill: " + pc.Name + " (" + pc.location + ")");
			} else {
				System.out.println("got sent a null pc");
			}
		}
	}
	
	synchronized public void delete(playerConnect pc) {
		broadcast(new SD_PlayerDel(pc.Name), pc.Name);
	}
	
	kworldServer()
	{
		running = true;
	}
	
	public static void main(String args[])
	{
		listenServer = new kworldServer();
		
		connectingPlayers = new LinkedList<playerConnect>();
		connectedPlayers = new Hashtable<String, playerConnect>();
		locations = new locationManager();
		
		listenServer.start();
		try {
			listenServer.join();
		} catch (InterruptedException e) {}
	}
	
}
